{
  description = "NixOS flake";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
    home-manager = {
      url = github:nix-community/home-manager;
      inputs.nixpkgs.follows = "nixpkgs"; 
    };
  };

  outputs = { self, nixpkgs, home-manager, ... }@inputs: {
    nixosConfigurations.nixos = nixpkgs.lib.nixosSystem {
      system = "x86_64-linux";
      specialArgs = { inherit inputs; }; # allows access to flake inputs in nixos modules
      modules = [
        ./configuration.nix
	home-manager.nixosModules.home-manager
        {
          home-manager.useGlobalPkgs = true; # makes hm use nixos's pkgs value
          home-manager.extraSpecialArgs = { inherit inputs; }; # allows access to flake inputs in hm modules
          home-manager.users.user.imports = [ ./home.nix ];
        }
      ];
    };
  };
}
